<!DOCTYPE html>
<html lang="en"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
    <meta charset="UTF-8">
    <title>Detail Account Institut</title>
</head>
<body>
<main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4 bd-layout">
    <div th:include="sidebar/sidebar_setting::sidebar_setting" th:remove="tag">
        sidebar
    </div>
    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5>Pengaturan Account</h5>
                    </div>
                    <div class="card-body">
                        <div class="row mb-3">
                            <div class="col-md-12 text-end">
                                <button class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#exampleModal">
                                    + Tambah Account
                                </button>

                                <a th:href="@{/accountInstitut}" class="btn btn-sm btn-danger">
                                    Kembali
                                </a>
                                <div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                                    <div class="modal-dialog modal-xl">
                                        <form th:action="@{/accountInstitut/save}" method="post">
                                            <input type="hidden" th:value="${institut.id}" name="institut">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                                                </div>
                                                <div class="modal-body text-start">
                                                    <div class="row mb-2">
                                                        <div class="col-md-6">
                                                            <!-- Additional Controls Here -->
                                                        </div>
                                                        <div class="col-md-6">
                                                            <form method="get" id="filterForm">
                                                                <select name="sub" id="select" class="form-select" style="width: 100%;">
                                                                    <option value="">-- Pilih Tipe Akun --</option>
                                                                    <option th:each="accountType : ${T(id.ac.tazkia.accounting.entity.AccountType).values()}"
                                                                            th:value="${accountType}" th:text="${accountType}">AKTIVA</option>
                                                                </select>
                                                                <button type="button" id="filterButton" class="btn btn-primary mt-2 btn-sm">Tampilkan Data</button>
                                                                <button type="button" id="filterAll" class="btn btn-outline-danger mt-2 btn-sm">Hapus Filter</button>
                                                            </form>
                                                        </div>
                                                    </div>
                                                    <div class="row mb-2">
                                                        <div class="col-md-12">
                                                            <button type="button" id="checkAll" class="btn btn-secondary mt-2 btn-sm">Check All</button>
                                                            <button type="button" id="uncheckAll" class="btn btn-secondary mt-2 btn-sm">Uncheck All</button>
                                                        </div>

                                                    </div>
                                                    <div class="table-responsive">
                                                        <table class="table table-bordered" id="accountTable">
                                                            <thead class="table-dark" style="--bs-table-bg: #0a3e8a">
                                                            <tr>
                                                                <th style="width: 5%;">Pilih</th>
                                                                <th>Kode Akun</th>
                                                                <th>Nama Akun</th>
                                                                <th>Tipe Akun</th>
                                                                <th>Posisi</th>
                                                            </tr>
                                                            </thead>
                                                            <tbody id="accountList">
                                                            <!-- Data akan diisi oleh JavaScript -->
                                                            </tbody>
                                                        </table>
                                                    </div>
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                                                    <button type="submit" class="btn btn-primary">Save changes</button>
                                                </div>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="row mb-3">
                            <div class="col-md-12 mb-3">
                                <b th:text="${institut.namaInstitut}"></b>
                            </div>
                            <div class="col-md-12">
                                <div class="table-responsive">
                                    <table class="table table-striped table-bordered">
                                        <thead>
                                        <tr>
                                            <th>No.</th>
                                            <th>Account</th>
                                            <th></th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        <tr th:each="data, row:${accountInstitut}">
                                            <td th:text="${(row.index + 1)}"></td>
                                            <td th:text="${data.account.code + ' - ' + data.account.name}"></td>
                                            <td>
                                                <a th:href="@{/accountInstitut/delete(id = ${data.id})}" class="btn btn-danger btn-sm">
                                                    Hapus
                                                </a>
                                            </td>
                                        </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
</main>
<div layout:fragment="footer" class="script">
    <script>
        document.addEventListener('DOMContentLoaded', function () {
            const selectElement = document.getElementById('select');
            const accountList = document.getElementById('accountList');
            const filterButton = document.getElementById('filterButton');
            const filterAllButton = document.getElementById('filterAll');
            const checkAllButton = document.getElementById('checkAll');
            const uncheckAllButton = document.getElementById('uncheckAll');

            // Function to fetch data and populate table
            function fetchData(url) {
                fetch(url)
                    .then(response => response.json())
                    .then(data => {
                        accountList.innerHTML = '';

                        data.data.forEach((account) => {
                            const row = document.createElement('tr');

                            const checkboxCell = document.createElement('td');
                            checkboxCell.style.width = '5%';
                            const checkbox = document.createElement('input');
                            checkbox.type = 'checkbox';
                            checkbox.className = 'form-check-input';
                            checkbox.name = 'account';
                            checkbox.value = account.id;

                            checkbox.addEventListener('change', () => {
                                if (checkbox.checked) {
                                    selectedCheckboxes.add(checkbox.value);
                                } else {
                                    selectedCheckboxes.delete(checkbox.value);
                                }
                            });

                            checkboxCell.appendChild(checkbox);
                            row.appendChild(checkboxCell);

                            const codeCell = document.createElement('td');
                            codeCell.textContent = account.code;
                            row.appendChild(codeCell);

                            const accountCell = document.createElement('td');
                            accountCell.textContent = account.name;
                            row.appendChild(accountCell);

                            const typeAccount = document.createElement('td');
                            typeAccount.textContent = account.accountType;
                            row.appendChild(typeAccount);

                            const balanceType = document.createElement('td');
                            balanceType.textContent = account.nominalBalance;
                            row.appendChild(balanceType);

                            accountList.appendChild(row);
                        });
                    })
                    .catch(error => console.error('Error fetching data:', error));
            }

            // Initial fetch when modal is opened
            document.getElementById('exampleModal').addEventListener('show.bs.modal', function () {
                fetchData('/public/api/account/list');
            });

            filterButton.addEventListener('click', function () {
                const sub = selectElement.value;
                const url = sub ? `/public/api/account/list?sub=${sub}` : '/public/api/account/list';
                fetchData(url);
            });

            filterAllButton.addEventListener('click', function () {
                selectElement.value = '';
                fetchData('/public/api/account/list');
            });

            checkAllButton.addEventListener('click', function () {
                document.querySelectorAll('#accountList input[type="checkbox"]').forEach(checkbox => checkbox.checked = true);
            });

            uncheckAllButton.addEventListener('click', function () {
                document.querySelectorAll('#accountList input[type="checkbox"]').forEach(checkbox => checkbox.checked = false);
            });

            // Reset checkboxes when modal is closed
            document.getElementById('exampleModal').addEventListener('hidden.bs.modal', function () {
                document.querySelectorAll('#accountList input[type="checkbox"]').forEach(checkbox => checkbox.checked = false);
                selectElement.value = '';
                fetchData('/public/api/account/list');
            });

            $('#select').select2({
                theme: 'bootstrap-5',
                placeholder: '- Tipe Akun -'
            });
        });
    </script>
</div>
</body>
</html>